<?php

namespace Drupal\danse\Commands;

use Drupal\danse\Service;
use Drush\Commands\DrushCommands;

/**
 * A Drush commandfile.
 */
class DanseCommands extends DrushCommands {

  /**
   * The DANSE service.
   *
   * @var \Drupal\danse\Service
   */
  protected Service $danse;

  /**
   * DanseCommands constructor.
   *
   * @param \Drupal\danse\Service $danse
   *   The DANSE service.
   */
  public function __construct(Service $danse) {
    parent::__construct();
    $this->danse = $danse;
  }

  /**
   * Create notifications.
   *
   * @usage danse:notifications:create
   *   Creates all outstanding notifications.
   *
   * @command danse:notifications:create
   * @aliases dnc
   */
  public function createNotifications(): void {
    $this->danse->createNotifications();
  }

}
